/*-------------------------------------------------------------------

   HEADER FILE FOR XMS.LIB - COPYRIGHT STEFANO COSTA, 1998

-------------------------------------------------------------------*/


// DEFINITIONS //////////////////////////////////////////////////////

typedef unsigned int HANDLE;
typedef struct       {  HANDLE         Handle;
                        unsigned long  ItemSize; } EMB_Array;

// GLOBAL VARIABLES /////////////////////////////////////////////////

unsigned char  BL_Info;             // CONTAINS INFORMATION FROM bl
                                    // REGISTRY SETTED BY THE FUNC-
                                    // TIONS - MAINLY USED TO CHECK
                                    // XMS_XxxToXxx ERRORS
                                    
char           NOMEM, NOHANDLES;    // FLAGS - *DO NOT MODIFY*


// USER FUNCTIONS ///////////////////////////////////////////////////

//GENERAL

HANDLE         XMS_Alloc(unsigned int);
unsigned int   XMS_BlockSize(HANDLE);
int            XMS_ConvToExt(unsigned long, void far *, HANDLE);
int            XMS_Destall(void);
int            XMS_ExtToConv(unsigned long, HANDLE, void far *);
int            XMS_ExtToExt(HANDLE, HANDLE);
int            XMS_Free(HANDLE);
unsigned int   XMS_FreeHandles(void);
unsigned int   XMS_FreeSize(void);
int            XMS_Install(void);
int            XMS_Lock(HANDLE);
unsigned int   XMS_MaxBlockSize(void);
int            XMS_Realloc(unsigned int, HANDLE);
int            XMS_Unlock(HANDLE);


//EMB_Array NEAR DATA

int            XMS_ArrayAlloc(unsigned long, unsigned int, EMB_Array *);
int            XMS_ArrayCopy(EMB_Array *, EMB_Array *);
int            XMS_ArrayFree(EMB_Array *);
int            XMS_ArrayLock(EMB_Array *);
int            XMS_ArrayRead(EMB_Array *, unsigned long, void far *, unsigned long);
int            XMS_ArrayRealloc(unsigned long, EMB_Array *);
int            XMS_ArrayWrite(void far *, EMB_Array *, unsigned long, unsigned long);
unsigned int   XMS_ArraySize(EMB_Array *);
int            XMS_ArrayUnlock(EMB_Array *);


//EMB_Array FAR DATA

int            XMS_ArrayFarAlloc(unsigned long, unsigned int, EMB_Array far *);
int            XMS_ArrayFarCopy(EMB_Array far *, EMB_Array far *);
int            XMS_ArrayFarFree(EMB_Array far *);
int            XMS_ArrayFarLock(EMB_Array far *);
int            XMS_ArrayFarRead(EMB_Array far *, unsigned long, void far *, unsigned long);
int            XMS_ArrayFarRealloc(unsigned long, EMB_Array far *);
int            XMS_ArrayFarWrite(void far *, EMB_Array far *, unsigned long, unsigned long);
unsigned int   XMS_ArrayFarSize(EMB_Array far *);
int            XMS_ArrayFarUnlock(EMB_Array far *);